
#Region "Header Information"
' -----------------------------------------------------------------------------
' Project: [project name]
' Form/Class  : [form name]
' 
' -----------------------------------------------------------------------------
' <summary>
' 
'   
' 
' </summary>
' <remarks>
'
' </remarks>
' Revision History
' Date       Name            Description
' ========   ============    ===========
' ??/??/08   Patrick Roy     Created form and routines 
'
'
' </history>
'
'
' -----------------------------------------------------------------------------
#End Region
Imports System.Net.Mail 


Public Class clsMail
     Private CLASS_NAME As String = MyBase.GetType().Name

#Region "Enums"
     Public Enum EV_Error_Type
          oError = 10
          oInformation = 20
          oWarning = 30
          oSQL_DATA = 40
     End Enum
     Public Enum Importance
          Normal = 0 ' Normal Importance
          Low = 1 ' Low Importance
          High = 2 ' High Importance
     End Enum
#End Region 'Enums
#Region "Constants"
     Public Const SMTP_SEVER As String = "smtp.ashleyfurniture.com"
     Public Const SEND_TO_EMAILADDRESS As String = "proy@ashleyfurniture.com"
#End Region  'Constants

#Region "Public/Private variables"
     Private m_Attachments As Object
     Private m_SENDTO As String
     Private m_SENDER As String
     Private m_SMTP_CLIENT As String
     Private m_MailCCAddress As String
     Private m_Message As String
     Private m_MsgTitle As String
     Private m_MsgCONTENT As String
     Private m_SUBJECT As String

#End Region 'Public/Private variables

#Region "Properties"
     Public Property MsgSENDTO() As String
          Get
               Return m_SENDTO
          End Get
          Set(ByVal value As String)
               m_SENDTO = value
          End Set
     End Property
     '---------------------------------
     Public Property MsgSENDER() As String
          Get
               Return m_SENDER
          End Get
          Set(ByVal value As String)
               m_SENDER = value
          End Set
     End Property
     '---------------------------------
     Public Property MailCCADDRESS() As String
          Get
               Return m_MailCCAddress
          End Get
          Set(ByVal value As String)
               m_MailCCAddress = value
          End Set
     End Property
     '---------------------------------
     Public Property MailMESSAGE() As String
          Get
               Return m_Message
          End Get
          Set(ByVal value As String)
               m_Message = value
          End Set
     End Property
     '---------------------------------
     Public Property MailSUBJECT() As String
          Get
               Return m_SUBJECT
          End Get
          Set(ByVal value As String)
               m_SUBJECT = value
          End Set
     End Property
     '---------------------------------

#End Region 'Properties
#Region "Functions and subroutines"
     Public Function SendMailMessage(ByVal oImportance As Importance) As Integer
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SendMailMessage"
          '--------------------------------------
          'Dim ErrMessage As MailMessage
          Dim message As MailMessage = Nothing
          Dim emailClient As SmtpClient = Nothing
          Try
               Me.MsgSENDTO = SEND_TO_EMAILADDRESS
               '................................
               If ValidateMailItems() Then
                    '^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                    message = New MailMessage(MsgSENDER, MsgSENDTO, MailSUBJECT, MailMESSAGE)
                    message.Priority = oImportance
                    '-------------------------------
                    emailClient = New SmtpClient(SMTP_SEVER)
                    '--------------------------------
                    emailClient.Send(message)
                    '..........................................
               Else

               End If
               'Write to the EventViewer that there was a problem with sending the Email
               'WriteToEventViewer("SendEmail", sMsg, "WorkflowLog", 1, EventType.TypeError)
          Catch ex As SmtpException
               Dim sMsg As String
               '..........................................
               sMsg = "Unable to send Email" & Chr(10) & Chr(13) & _
               "Sender: " & MsgSENDER & Chr(10) & Chr(13) & _
               "Sending To: " & MsgSENDTO & Chr(10) & Chr(13) & _
               "Subject: " & MailSUBJECT & Chr(10) & Chr(13) & _
               "Message: " & MailMESSAGE
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               'If g_oSetupData.DEBUG_ON_OFF Then
               '     gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Could NOT send Email Message" & sMsg, ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               'Else
               '     g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "Could NOT send Email Message" & sMsg, CLASS_NAME, FUNCTION_NAME)
               'End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               'If g_oSetupData.DEBUG_ON_OFF Then
               '     gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               'Else
               '     g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               'End If
          Finally
               '------------------------------------
               If Not message Is Nothing Then
                    message = Nothing
               End If
               '.....................
               If Not emailClient Is Nothing Then
                    emailClient = Nothing
               End If
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function ValidateMailItems() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CheckForMailItems"
          '--------------------------------------
          Dim strMsg As String = Nothing
          Dim strMsgTitle As String = Nothing
          Try
               '-----------------------------------------
               If Me.MsgSENDER <> "" And Me.MsgSENDTO <> "" And Me.MailMESSAGE <> "" And Me.MailSUBJECT <> "" Then
                    Return True
               Else
                    strMsg = ""
                    strMsgTitle = ""
                    MessageBox.Show(strMsg, strMsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                    Return False
               End If
               '..................................
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               'If g_oSetupData.DEBUG_ON_OFF Then
               '     gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               'Else
               '     g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               'End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
               strMsg = Nothing
               strMsgTitle = Nothing
          End Try
     End Function

#End Region 'Functions and subroutines

#Region "Class routines"
     Public Sub New()

     End Sub
     Protected Overrides Sub Finalize()
          MyBase.Finalize()
     End Sub
#End Region 'Class routines


End Class
